<template>
	<div class="flex-col md:rounded-lg lg:rounded bg-white px-4 md:px-6 lg:px-10 py-6 lg:py-10 mb-2">
		<div class="flex justify-between items-center">
			<div class="flex items-center">
				<MkSuccessIcon aria-label="Email" />
				<h2
					class="font-secondary-font-regular text-xl md:text-2xl leading-6 md:leading-7 lg:leading-8 pl-4 lg:pl-6"
					v-html="page.email"
				>
				</h2>
			</div>
			<div class="cursor-pointer">
				<a
					v-if="AUTHENTICATED"
					tabindex="0"
					role="button"
					ref="sign_out_button"
					class="focus:ring-1 focus:ring-black font-primary-font-bold ml-1 mk-link"
					@click="signOut"
					@keypress.enter="signOut"
					>Sign out</a
				>
				<a
					v-else
					ref="mail_edit_button"
					tabindex="0"
					aria-label="Edit Email"
					role="button"
					href="javascript:;"
					class="focus:ring-1 focus:ring-black font-primary-font-bold text-base leading-6 mk-link"
					@click="$emit('edit-email')"
					@keypress.enter="$emit('edit-email')"
					>Edit</a
				>
			</div>
		</div>
		<div v-if="FEATURE_GIFT" class="flex w-full pl-12 md:pl-14 lg:pl-16 pt-7 md:pt-5 lg:pt-10">
			<MkCheck :checked="GIFT" radio-title="This is a gift" class="mr-3" @change="gifted" />
			<MkGiftIcon />
		</div>
		<p class="font-primary-font-light text-base leading-6 pt-4 pl-12 md:pl-14 lg:pl-16">
			{{ (AUTHENTICATED && CUSTOMER_EMAIL) || GUEST_EMAIL || value.email }}
		</p>
		<p
			v-if="value['password'] || AUTHENTICATED"
			class="font-primary-font-light text-base leading-6 pt-2 lg:pt-4 pl-12 md:pl-14 lg:pl-16"
		>
			••••••••
		</p>
	</div>
</template>
<script>
import { mapState } from 'vuex';
import MkSuccessIcon from '~/components/D2C/atoms/MkSuccessIcon.vue';
import MkCheck from '~/components/D2C/atoms/MkCheck.vue';
import MkGiftIcon from '~/components/D2C/atoms/MkGiftIcon.vue';
export default {
	name: 'MkCheckoutAccount',
	components: {
		MkSuccessIcon,
		MkCheck,
		MkGiftIcon,
	},
	props: {
		value: {
			type: Object,
			default: () => {},
		},
		lastEdit: {
			type: String,
			default: 'mail',
		},
		page: {
			type: Object,
			default: () => {},
		},
	},
	computed: {
		...mapState('CHECKOUT_STORE', ['FEATURE_GIFT']),
		...mapState('USER_STORE', ['AUTHENTICATED', 'CUSTOMER_PROFILE', 'CUSTOMER_EMAIL']),
		...mapState('CART_STORE', [
			'GIFT',
			'SUB_TOTAL_PRICE',
			'DISCOUNT_PRICE',
			'LINE_ITEMS',
			'TOTAL_PRICE',
			'GUEST_EMAIL',
		]),
	},
	mounted() {
		if(this.lastEdit === 'mail' || this.lastEdit === '' || this.lastEdit === 'Info'){
			this.$root.$utility.elementFocus(this, 'mail_edit_button')
			this.$root.$utility.elementFocus(this, 'sign_out_button')
		}
		// console.log(this.CUSTOMER_PROFILE.email, this.value, '--checking--')
	},
	methods: {
		async gifted(value) {
			this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
			value = !value;
			const $data = {
				action: 'GIFT',
				gift: value,
			};
			await this.$store.dispatch('CART_STORE/UPDATE_CART_ACTION', $data);
			this.$emit('gift-triggered');
			this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
			this.giftTealium(value ? 'clicked_gift_on' : 'clicked_gift_off', value);
		},
		async signOut() {
			this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
			await this.$store.dispatch('USER_STORE/SIGN_OUT', { path: '/' });
			this.$emit('sign-out');
			this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
		},
		giftTealium(key, value) {
			const customerDetails = this.$store.state.USER_STORE.CUSTOMER_DETAILS_D2C_TEALIUM;
			const tealiumPayload = {
				event_category: 'Gift Purchase',
				gift_purchase: value,
				customer_uid: this.CUSTOMERID || '',
				cart_product_id: [...new Set(this.LINE_ITEMS.map((x) => x.productId))],
				cart_product_quantity: [...new Set(this.LINE_ITEMS.map((x) => x.quantity.toFixed(0) || '1'))],
				cart_product_sku: [...new Set(this.LINE_ITEMS.map((x) => x.variant.sku))],
				cart_total_items: this.LINE_ITEMS.length.toFixed(0),
				cart_total_value: this.$root.$utility.centsToDollarsConvert(this.SUB_TOTAL_PRICE),
				cart_discount: [this.$root.$utility.centsToDollarsConvert(this.DISCOUNT_PRICE)],
				event_value: [this.$root.$utility.centsToDollarsConvert(this.TOTAL_PRICE)],
				...customerDetails,
			};
			const listPriceArray = [];
			const productListPrice = [...new Set(this.LINE_ITEMS.map((x) => x.price))];
			productListPrice.forEach((el) => {
				if (el.value) {
					listPriceArray.push(this.$root.$utility.centsToDollarsConvert(el.value.centAmount));
				}
			});
			tealiumPayload.cart_product_price = listPriceArray;
			tealiumPayload.cart_product_list_price = listPriceArray;
			tealiumPayload.event_action =
				key === 'clicked_gift_on' ? 'Checked sidecart gift box' : 'Un-checked sidecart gift box';
			this.$root.$telium.setTealiumPayload(key, tealiumPayload);
		},
	},
};
</script>
